;Displays errors when necessary

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN AppExit,IGetKey,IPutS,DispHexA,AppExitNoDrv,Explore_ListDirectory,vputstring,FunkyLine,DialogBox,DispA
 EXTERN sOK

Explorer_Error:
       push hl
       push af
       or a
       jr z,$F
       ld b,a
       ld hl,sMyErrorTable
       ld de,3
EE_Loop:
       ld a,(hl)
       or a
       jr z,$F
       add hl,de
       cp b
       jr nz,EE_Loop
       dec hl
       ld a,(hl)
       ld d,a
       dec hl
       ld a,(hl)
       ld e,a
       pop af
       pop hl
       push de
       push af
$$:	pop af
       pop hl
       push hl
       push af
       ld l,13
	ld h,15
	ld e,79
	ld d,47
	call DialogBox
	ld bc,13*256+24
	ld e,78
	call FunkyLine
	ld hl,16*256+16
	ld (pencol),hl
	ld hl,sErrorText
	call vputstring
	pop af
	call DispA
	ld hl,25*256+16
	ld (pencol),hl
	pop hl
	call vputstring
	push hl
	ld hl,32*256+16
	ld (pencol),hl
	pop hl
	call vputstring
	ld hl,40*256+41
	ld (pencol),hl
	ld hl,sOK
	call vputstring
	ld bc,13*256+40
	ld e,78
	call FunkyLine
	B_CALL RunIndicOff
	call IGetKey
	jr Explore_ListDirectory

USBErrorNoDrv:
	B_CALL ClrLCDFull
	B_CALL HomeUp
	ld hl,sUSBNoDrv
	call IPutS
	call IGetKey
	jr AppExitNoDrv
USBErrorVersion:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sUSBVersion
       call IPutS
       call IGetKey
       jr AppExitNoDrv

USBError:
	B_CALL ClrLCDFull
	B_CALL HomeUp
	ld hl,sErrorText
	call IPutS
       U_CALL GetErrorCode
	ld a,b
	call DispHexA
       ld a,c
	call DispHexA
       ld a,b
       cp errInit
       jr nz,$F
       ld b,c ;if errInit, use sub error code for message
$$:    ld hl,0003h
	ld (currow),hl
	call getErrorString
	jr nc,$F
	ld hl,sUSBError
$$:	call IPutS
	call IGetKey
       jr AppExit

getErrorString:
	ld hl,sUSBErrorTable-3
	ld de,3
$$:	add hl,de
	ld a,(hl)
	or a
	jr z,$F
	cp b
	jr nz,$B
	inc hl
	B_CALL ldhlind
	ret
$$:	scf
	ret


sErrorText:
	DB "ERROR ",0
sUSBNoDrv:
	DB "USBDRV8X (usb8x)"
	DB "was not         "
	DB "detected.",0
sUSBVersion:
       DB "msd8x requires  "
       DB "usb8x v0.11 or  "
       DB "higher to run.",0
sUSBError:
	DB "A problem       "
	DB "occurred and    "
	DB "msd8x cannot    "
	DB "continue.",0
sUSBErrorTable:
       DB errPort82
       DW sUSBInitProblem
	DB errNoDevice
	DW sUSBNoDevice
	DB errMSDInvalidPartition
	DW sUSBInvalidPartition
	DB errMSDNoParts
	DW sUSBNoParts
	DB errMSDNoParts32
	DW sUSBNoParts32
       DB errMSDSendCmd
       DW sUSBBadCmd
       DB errMSDFailedCmd
       DW sUSBFailedCmd
       DB errMSDCmdTimeout
       DW sUSBBadCmd
       DB errMSDCmdRefused
       DW sUSBRefused
	DB 0
sMyErrorTable:
       DB errPort8C
       DW sLowBatteries
       DB errMSDDuplicateFound
       DW sDuplicateFound
       DB errMSDNoMoreMemory
       DW sNoMoreMemory
       DB errMSDNotFile
       DW sNotFile
       DB errMSDNotValidPath
       DW sNotValidPath
       DB errMSDCorruptFile
       DW sCorruptFile
       DB errMSDNotFound
       DW sNotFound
       DB errMSDNotEnoughMem
       DW sNotEnoughMem
       DB errMSDAlreadyExists
       DW sAlreadyExists
       DB errMSDVarEmpty
       DW sVarEmpty
       DB 0
sUSBRefused:
       DB "The mass storage"
       DB "driver cannot   "
       DB "communicate with"
       DB "this drive. Try "
       DB "another.",0
sLowBatteries:
       DB "The mass storage"
       DB "driver could not"
       DB "start. Check for"
       DB "low batteries   "
       DB "and try again.",0
sUSBBadCmd:
       DB "The drive is not"
       DB "responding to   "
       DB "commands. Try   "
       DB "running msd8x   "
       DB "again.",0
sUSBFailedCmd:
       DB "The drive is not"
       DB "accepting any   "
       DB "commands. Make  "
       DB "sure your drive "
       DB "is compatible.",0
sUSBInitProblem:
       DB "msd8x could not "
       DB "be initialized. "
       DB "Running it again"
       DB "may solve the   "
       DB "problem.",0
sUSBNoParts32:
	DB "Only FAT32      "
	DB "partition(s)    "
	DB "were found. Try "
	DB "reformatting    "
	DB "drive as FAT16.",0
sUSBNoParts:
	DB "No valid FAT16  "
	DB "partitions were "
	DB "found.",0
sUSBNoDevice:
	DB "A flash drive   "
	DB "was not         "
	DB "detected. If    "
	DB "connected, try  "
	DB "running again.",0
sUSBInvalidPartition:
	DB "The detected    "
	DB "FAT16 partition "
	DB "is invalid.",0
sVarEmpty:
       DB "This variable",0
       DB "is empty.",0
sAlreadyExists:
       DB "This file is",0
       DB "already here.",0
sCorruptFile:
       DB "This file is",0
       DB "corrupt.",0
sNotEnoughMem:
       DB "There is not",0
       DB "enough free RAM.",0
sNotFound:
       DB "File/directory",0
       DB "was not found.",0
sNotValidPath:
       DB "This directory",0
       DB "is invalid.",0
sNotFile:
       DB "This is not a",0
       DB "file.",0
sDuplicateFound:
       DB "Duplicate variable",0
       DB "was found.",0
sNoMoreMemory:
       DB "There is no more",0
       DB "free memory.",0
