;Run MirageOS/Ion program

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN Explorer_Error,InitProg,IGetKey,IPutS,cmpstrb
 EXTERN sRoot,FileHeader

Explore_RunProg:
       ;type is 8XP, so attempt to run program
       di
       ld a,05h
       out (5),a
       ld de,0C000h
       ld a,26h
       ld (de),a
       inc de
       ld a,90h
       ld (de),a
       inc de
       ld a,(file_start)
       ld (de),a
       inc de
       ld a,(file_start+1)
       ld (de),a
       inc de
       ld a,(file_cur)
       ld (de),a
       inc de
       ld a,(file_cur+1)
       ld (de),a
       inc de
       ld hl,current_dir
       ld bc,128
       ldir
       xor a
       out (5),a
       ei
       ld hl,runprogLauncher
       ld de,cmdShadow+104
       ld bc,runprogLauncherEnd-runprogLauncher
       ldir
       xor a
       out (20h),a
       ld hl,sMirageName
       rst 20h
       B_CALL FindApp
       ld (OP3),a
       ld hl,sMirageError
       ld a,1
       jr c,Explorer_Error
       ;copy program directly to RAM
       ld hl,current_dir+1
       ld de,temp_file
       ld a,(hl)
       dec hl
$$:    ld a,(hl)
       ld (de),a
       or a
       jr z,Explore_RP_Done
       inc hl
       inc de
       jr $B
Explore_RP_Done:
       ld a,'/'
       ld (de),a
       inc de
       ld hl,cur_entry
       U_CALL FAT_nameConvertFrom11
       ld hl,temp_file
       ld de,temp_handle
       push de
       U_CALL DOS_openFile
       pop hl
       ld de,OP4
       ld bc,4
       push de
       U_CALL DOS_fileRead
       pop hl
       ld de,FileHeader
       ld b,4
       call cmpstrb
       jr nz,returnPoint
       ld de,0
       ld hl,37h
       ld bc,temp_handle
       U_CALL DOS_fileSeek
       ld hl,temp_handle
       ld de,OP4
       ld bc,2
       U_CALL DOS_fileRead
       ld hl,(OP4)
       ld de,3Bh
       add hl,de
       ld de,0
       ld bc,temp_handle
       U_CALL DOS_fileSeek
       ld hl,temp_handle
       ld de,OP4
       ld bc,2
       U_CALL DOS_fileRead
       ld hl,sMirageprogname
       rst 20h
       ld hl,(OP4)
       B_CALL EnoughMem
       ld hl,sMemError
       ld a,0
       jr c,Explorer_Error
       ld hl,(OP4)
       B_CALL CreateProtProg
       inc de
       inc de
       push de
       ld hl,temp_handle
       ld bc,(OP4)
       U_CALL DOS_fileRead
       U_CALL HostKill
       U_CALL DriverKill
       B_CALL ClrLCDFull
       B_CALL HomeUp
       B_CALL GrBufClr
       ld hl,savesscreen
       ld (hl),0
       ld de,savesscreen+1
       ld bc,767
       ldir
       ld hl,textShadow
       ld (hl),' '
       ld de,textShadow+1
       ld bc,127
       ldir
       pop de
       ld a,(de)
       cp 0BBh
       jr nz,RunProg_Basic
       inc de
       ld a,(de)
       dec de
       cp 6Dh
       jr nz,RunProg_Basic
$$:    ld a,(OP3)
       ld b,a
       ld c,6
       push bc
       ld hl,sMirageprogname
       rst 20h
       B_CALL ChkFindSym
       dec hl
       ld a,(hl)
       inc hl
       ld (cmdShadow+21),a
       xor a
       ld (cmdShadow+24),a
       ld (cmdShadow+42),a
       pop bc
       in a,(6)
       push af
       ;ld a,00001000b
       jp cmdShadow+104
RunProg_Basic:
;check to make sure valid MirageOS BASIC program
       ld a,(de)
       cp 3Eh ;":"
       jr z,$B
returnPoint:
       im 1
       xor a
       ld (iy+sGrFlags),a
       set fullScrnDraw,(iy+apiFlg4)
       res plotLoc,(iy+plotFlags)
       res bufferOnly,(iy+plotFlag3)
       call deleteTempProgram
       B_CALL DelRes
       ld hl,sRoot
       ld de,current_dir
       ldi
       ldi
       ld hl,0
       ld (file_cur),hl
       ld (file_start),hl
       di
       ld a,05h
       out (5),a
       ld hl,0C000h
       ld a,(hl)
       cp 26h
       jr nz,$F
       inc hl
       ld a,(hl)
       cp 90h
       jr nz,$F
       inc hl
       ;pointing to file_cur/file_start
       ld a,(hl)
       ld (file_start),a
       inc hl
       ld a,(hl)
       ld (file_start+1),a
       inc hl
       ld a,(hl)
       ld (file_cur),a
       inc hl
       ld a,(hl)
       ld (file_cur+1),a
       inc hl
       ld de,current_dir
       ld bc,128
       ldir
$$:    xor a
       out (5),a
       ei
       jp InitProg
runprogLauncher:
       out (c),b
       ;call 4191h ;setupint WHY DOESN'T THIS WORK?!
       call 4131h ;runprog
       pop af
       out (6),a
       jp returnPoint
runprogLauncherEnd:
deleteTempProgram:
       ld hl,sMirageprogname
       rst 20h
       B_CALL ChkFindSym
       ret c
       B_CALL DelVarArc
       ret

sMirageName:
       DB AppObj,"MirageOS"
sMirageprogname:
       DB ProtProgObj,12h,34h,56h,78h,0
sMirageError:
       DB "MirageOS was",0
       DB "not found.",0
sMemError:
       DB "You do not have",0
       DB "enough free RAM.",0