;Views plain-text files

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN Explore_KeyLoop,VEraseEOL,IGetKey,fastCopy,Explore_ListDirectoryStay,vputstring,myKeyHook

ViewFile:
       ld a,(cur_entry+11)
       and 18h
       jr nz,Explore_KeyLoop ;if directory, don't even bother
       B_CALL ClrLCDFull
       ld hl,current_dir+1
       ld a,(hl)
       dec hl
       ld de,temp_file
       or a
       jr z,$F
VF_1_Loop:
       ld a,(hl)
       ld (de),a
       inc hl
       inc de
       or a
       jr nz,VF_1_Loop
       dec de
$$:    ld a,'/'
       ld (de),a
       inc de
       ld hl,cur_entry
       U_CALL FAT_nameConvertFrom11
       ld hl,temp_file
       ld de,temp_handle
       U_CALL DOS_openFile
DisplayFile:
       B_CALL GrBufClr
       set textWrite,(iy+sGrFlags)
       ld hl,temp_handle
       ld de,appData
       ld bc,512
       U_CALL DOS_fileRead
       ld (max_offset),bc
       ld hl,0
       ld (text_offset),hl
       ld (text_offset+2),hl
       ld (wAddress),hl
       ld (pencol),hl
       ld (wStart),hl
       ld (OP4+1),hl
       ld a,58
       ld (OP5),a
       res alterAddress,(iy+msd8xFlags)
VF_Display:
       ;display data
       ld hl,0
       ld (pencol),hl
       ld bc,512
VF_DisplayLoop:
       push bc
       call getTextByte
       pop bc
       jr c,VF_DisplayDone
       push bc
       cp 09h
       jr nz,$F
       ld a,06h
$$:    cp 0Ah
       jr z,VF_DisplaySkip
       cp 0Dh
       jr nz,$F
       ld c,95
       call VEraseEOL
       call VNewLine
       ld c,95
       call VEraseEOL
       xor a
       ld (pencol),a
       jr VF_DisplaySkip
$$:    cp 5Bh
       jr nz,$F
       ld a,0C1h
$$:    B_CALL VPutMap
       ld a,(pencol)
       cp 90
       jp m,VF_DisplaySkip
       ld c,95
       call VEraseEOL
       call VNewLine
       ld c,95
       call VEraseEOL
       xor a
       ld (pencol),a
VF_DisplaySkip:
       ld a,(OP5)
       ld b,a
       ld a,(penrow)
       cp b
       pop bc
       jp p,VF_DisplayDone
       dec bc
       ld a,b
       or c
       jr nz,VF_DisplayLoop
VF_DisplayDone:
       ld c,95
       call VEraseEOL
       call fastCopy
       bit alterAddress,(iy+msd8xFlags)
       jr z,$F
       ld hl,(OP4+1)
;       ld (wAddress),hl
$$:    res alterAddress,(iy+msd8xFlags)
VF_KeyLoop:
       call IGetKey
       cp kQuit
       jr z,VF_Quit
       cp kMode
       jr z,VF_Quit
       cp kClear
       jr z,VF_Quit
       ;cp kUp
       ;jr z,VF_KeyUp
       cp kDown
       jr z,VF_KeyDown
       ;cp kCapF
       ;jr z,VF_Search
       cp kYequ
       jr z,ViewFile
       ;cp kGraph
       jr VF_KeyLoop
$$:    call getTextByte
       jr nc,$B
       jr DisplayFile
VF_Quit:
       xor a
       ld (iy+sGrFlags),a
       jr Explore_ListDirectoryStay
VNewLine:
       xor a
       ld (pencol),a
       ld a,(penrow)
       add a,7
       ld (penrow),a
       ret
VF_Search:
       COMMENT ~
       ;set textWrite,(iy+sGrFlags)
       ;set write_on_graph,(iy+sGrFlags)
       ld hl,plotSScreen+(12*56)
       ld b,12
$$:    ld (hl),0FFh
       inc hl
       djnz $B
       ld hl,3900h
       ld (pencol),hl
       ld hl,sSearch
       call vputstring
       ld c,95
       call VEraseEOL
       call fastCopy
       call IGetKey
       ;set up edit buffer, get text to search for, and start parsing from current position
	ld hl,9B84h
	ld de,hook_temp+1
	ld bc,4
	ldir
	xor a
	ld (hook_temp),a
	bit 5,(iy+34h)
	jr z,$F
	inc a
	ld (hook_temp),a
$$:    ld hl,myKeyHook
	in a,(6)
	B_CALL EnRawKeyHook
	ld a,3
	ld (SmallEditCancelParse),a
	ld a,20
	ld (SmallEditColumnLeft),a
	ld a,75
	ld (SmallEditColumnRight),a
	ld a,57
	ld (SmallEditRow),a
	xor a
	ld (SmallEditPromptString),a
	inc a
	ld (SmallEditRowCount),a
	B_CALL InitSmallEditLine
       set shiftAlpha,(iy+shiftFlags)
       set shiftALock,(iy+shiftFlags)
	B_CALL StartSmallEdit
       push af
	res 5,(iy+34h)
	ld hl,hook_temp+1
	ld de,9B84h
	ld bc,4
	ldir
	ld a,(hook_temp)
	or a
	jr z,$F
	set 5,(iy+34h)
$$:    pop af
	cp kQuit
	jr z,VF_Ret
	ld hl,savesscreen
	ld bc,10
	B_CALL MemClear
	B_CALL ChkFindSym
	ld a,(de)
	or a
	jr z,VF_Ret
	and 00001111b
	ld b,a
	inc de
	inc de
	ex de,hl
	ld de,savesscreen
Text_CopyLoop:
       ld a,(hl)
       cp ':'
       jr nz,$F
$$:    ld (de),a
       inc hl
       inc de
       djnz Text_CopyLoop
       xor a
       ld (de),a
	B_CALL ReleaseSEdit
       ;if found, start displaying at that point
       ;if not found, start at beginning
       jr VF_KeyLoop
       ~
VF_Ret:
       B_CALL ReleaseSEdit
       jr DisplayFile
VF_KeyUp:
       ;rework this whle thing
       ld hl,plotSScreen+767-(12*7)
       ld de,plotSScreen+767
       ld bc,768-(12*7)
$$:    ld a,(hl)
       ld (de),a
       dec hl
       dec de
       dec bc
       ld a,b
       or c
       jr nz,$B
       call moveBackLine
       ld hl,0
       ld (pencol),hl
       ld a,6
       ld (OP5),a
       ld hl,(wAddress)
       ld (OP4+1),hl
       ld hl,(wStart)
       ld (wAddress),hl
       set alterAddress,(iy+msd8xFlags)
       jr VF_DisplayLoop
moveBackLine:
       ld hl,(wStart)
       ld de,appData
       add hl,de
       xor a
       ld (OP4),a
$$:    ld a,(hl)
       push af
       ld de,0
       ld (currow),de
       B_CALL PutC
       call IGetKey
       pop af
       cp 0Dh
       jr z,$F
       dec hl
       ;add to length
       push hl
       ld h,0
       ld l,a
       add hl,hl
       add hl,hl
       add hl,hl
       B_CALL SFont_Len
       pop hl
       ld a,(OP4)
       add a,b
       ld (OP4),a
       cp 90
       jp m,$B
       dec hl
$$:    inc hl
       ld de,appData
       sbc hl,de
       ld (wStart),hl
       ret
VF_KeyDown:
       ld hl,(wAddress)
       ld de,(max_offset)
       B_CALL cphlde
       jr nz,VF_KDGood
VF_KDContinue:
       ld ix,temp_handle
       bit 1,(ix+21)
       jr nz,VF_KeyLoop
VF_KDGood:
       ld hl,(wAddress)
       ld (OP4+1),hl
       ld hl,(wStart)
       ld (wAddress),hl
       call moveAheadLine
       ld hl,(wAddress)
       ld (wStart),hl
       ld hl,(OP4+1)
       ld (wAddress),hl
       ld hl,plotSScreen+(12*7)
       ld de,plotSScreen
       ld bc,768-(12*7)
       ldir
       ld hl,3900h
       ld (pencol),hl
       ld bc,512
       ld a,58
       ld (OP5),a
       jr VF_DisplayLoop
moveAheadLine:
       xor a
       ld (OP4),a
MAL_Loop:
       call getTextByte
       cp 0Dh
       jr z,$F
       ld h,0
       ld l,a
       add hl,hl
       add hl,hl
       add hl,hl
       B_CALL SFont_Len
       ld a,(OP4)
       add a,b
       ld (OP4),a
       cp 90
       jp m,MAL_Loop
       ret
$$:    call getTextByte
       ret
getTextByte:
       ld hl,(wAddress)
       ld de,(max_offset)
       B_CALL cphlde
       jr z,GTB_NewBuffer
GTB_Return:
       push hl
       ld de,appData
       add hl,de
       ld a,(hl)
       pop hl
       inc hl
       ld (wAddress),hl
       or a
       ret
GTB_NewBuffer:
       ld ix,temp_handle
       bit 1,(ix+21)
       scf
       ret nz
       ld hl,0
       ld (wAddress),hl
       ld hl,temp_handle
       ld de,appData
       ld bc,512
       U_CALL DOS_fileRead
       ld (max_offset),bc
       ld hl,0
       jr GTB_Return

       COMMENT ~
sSearch:
       DB "Search for: ",0
       ~
