;Utility routines

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON

IPutS11:
       push hl
       push bc
       ld bc,0
       ld (curRow),bc
       ld b,8
$$:    ld a,(hl)
       or a
       jr z,$F
       inc hl
       B_CALL PutC
       djnz $B
$$:    pop bc
       pop hl
       ret

myLoadCIndPaged:
       B_CALL LoadCIndPaged
inc_BHL:
       inc hl
inc_BHL_1:
       bit 7,h
       ret z
       inc b
       res 7,h
       set 6,h
       ret
myLoadDEIndPaged:
       B_CALL LoadDEIndPaged
       jr inc_BHL
BHL_plus_DE:
       add hl,de
       jr inc_BHL_1

Explore_QuickSort:
	;QuickSort
	;Input - HL is low, DE is high
	;if (high <= low), then terminate
	or a
	sbc hl,de
	ret nc
	add hl,de
	;pivot = partition(a, low, high)
	push de
	push hl
	call Explore_Partition
	pop hl
	;quicksort (a,low,pivot-1)
	push de
	dec de
	dec de
	call Explore_QuickSort
	pop hl
	inc hl
	inc hl
	pop de
	jr Explore_QuickSort
Explore_Partition:
	;Partition routine for quicksort.
	;Assume that interrupts are disabled and page 86h is active on port 7.
	;Parameters passed in are int low and int high (pointers)
	;Input - HL is low, DE is high
	;Output - Returns in DE (right)
	;pivot_item = a[low];
	ld (OP7),hl		;pivot_item
	;pivot = left = low
	ld (OP7+2),hl
	;right = high
	ld (OP7+4),de
	;left is HL, right is DE
	;while (left<right) {
Explore_P_1:
	or a
	sbc hl,de
Explore_P_1_LB:
	jr nc,Explore_P_2
	add hl,de
	;while (a[left] <= pivot_item) left++;
Explore_P_3:
	;HL is left.
	push de
	ld de,(OP7)
	call Explore_Sort_Compare
	pop de
	jr c,Explore_P_4
	;left++ now
	inc hl
	inc hl
	push hl
	ld bc,(OP7+4)
	inc bc
	inc bc
	sbc hl,bc
	pop hl
	jr nz,Explore_P_3
	;left went past the bounds of the array
	;this means the left pivot is greater than all.
	ld hl,(OP7)
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc de
	ld a,(de)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	dec hl
	ld a,(de)
	ld (hl),a
	ld a,c
	ld (de),a
	ret
	;while (a[right] < pivot_item) right--;
Explore_P_4:
	;DE is right.
	push hl
	ld hl,(OP7)
	call Explore_Sort_Compare
	pop hl
	jr c,Explore_P_5
	dec de
	dec de
	push hl
	ld hl,(OP7+2)
	or a
	sbc hl,de
	pop hl
	jr c,Explore_P_4
	jr z,Explore_P_4
	ld de,(OP7+2)
	ret
Explore_P_5:
	;if (left<right) SWAP(a,left,right)
	or a
	sbc hl,de
	jr nc,Explore_P_1_LB
	;}
	add hl,de
	ld bc,(OP7)
	or a
	sbc hl,bc
	jr nz,$F
	ld (OP7),de
$$:
	add hl,bc
	;SWAP them!
	ld c,(hl)
	inc hl
	ld b,(hl)
	dec hl
	ld a,(de)
	ld (hl),a
	inc de
	inc hl
	ld a,(de)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	ld a,c
	ld (de),a
	dec hl
	jr Explore_P_1
Explore_P_2:
	;a[low] = a[right];
	ld hl,(OP7+2)
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc de
	ld a,(de)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	dec hl
	ld a,(de)
	ld (hl),a
	ld a,c
	ld (de),a
	ret
	;}
Explore_Sort_Compare:
	;Input - HL,DE are pointers to page 86h entries to compare
	;Destroys AF only. Uses shadow registers.
	;Output - Z if DE = HL. C if HL > DE. NC if HL <= DE.
	push hl
	push de
	exx
	pop hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	pop hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;DE, HL are pointers
	ld a,87h
	out (7),a
	push hl
	push de
	ld bc,11
	add hl,bc
	ex de,hl
	add hl,bc
	ld a,(hl)
	and 10h
	ld b,a
	ld a,(de)
	and 10h
	cp b
	pop de
	pop hl
	jr nz,Explore_Sort_Compare_D
	ld b,11
Explore_Sort_Compare_L:
	ld a,(de)
	cp (hl)
	jr nz,Explore_Sort_Compare_D
	inc hl
	inc de
	djnz Explore_Sort_Compare_L
	xor a
Explore_Sort_Compare_D:
	ld a,86h
	out (7),a
	exx
	ret
Divide32:
	;DEHL is quotient when done. A is the remainder.
	ld c,a
	xor a
	ld b,32
Divide32_Loop:
	add hl,hl
	rl e
	rl d
	rla
	jr c,Divide32_Fit
	cp c
	jr c,Divide32_NoFit
Divide32_Fit:
	sub c
	inc l
Divide32_NoFit:
	djnz Divide32_Loop
	ret

IPutS8:
       push bc
       ld bc,0
       ld (currow),bc
       ld b,8
       push hl
$$:    ld a,(hl)
       B_CALL PutC
       inc hl
       djnz $B
       pop hl
       pop bc
       ret
compstr:
       ld a,(de)
       or a
       ret z
       cp (hl)
       ret nz
       inc hl
       inc de
       jr compstr

;Draws horizontal dotted line
;Input: bc = (x,y) coordinate of first point (lower left corner is (0,0))
;		   e = column to stop at
;Output: line drawn
FunkyLine:
	ld d,1
FunkyLine_Loop:
	B_CALL IPoint
	inc b
	inc b
	ld a,b
	cp e
	jp m,FunkyLine_Loop
	ret

vputstring:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL VPutMap
	jr vputstring

DispA:
	push hl
	ld c,-1
DispA_loop:
	inc c
	sub 10
	jr nc,DispA_loop
	add a,10
	push af
	ld a,c
	add a,'0'
	B_CALL VPutMap
	pop af
	add a,'0'
	B_CALL VPutMap
	pop hl
	ret

IGetKey:
		 push ix
       push bc
       push de
       push hl
       res onInterrupt,(iy+onFlags)
       B_CALL GetKey
       pop hl
       pop de
       pop bc
		 pop ix
       ret

IPutSUnicode:
;Display a unicode string descriptor
       ld     b,(hl)
       inc    hl
       inc    hl
       dec    b
       dec    b
$$:
       ld     a,(hl)
       or     a
       call   nz,IPutC
       inc    hl
       djnz   $b
       ret

IPutS:
       ld     a,(hl)
       inc    hl
       or     a
       ret    z
       call   IPutC
       jr     IPutS

IPutC:
       push   hl ;don't think these are necessary
       push   bc
       B_CALL PutC
       pop    bc
       pop    hl
       ret
       
 Var TempNum,2
GetHexA:
;lets user input an 8 bit number in hexadecimal
;prompt is at currow,curcol
;number is returned in a
	set curAble,(iy+curFlags)
	ld	b,2
	ld	hl,TempNum
getnumhloop:
   call IGetKey
	cp	2
	jp	nz,gnhnotback
	ld	a,b
	cp	2
	jp	z,gnhnotback
	ld	a,' '
   B_CALL PutMap
	ld	hl,curCol
	dec (hl)
	jp	GetHexA
gnhnotback:
	sub 142
	cp	10
	jp	c,gnhnumpressed
	sub 12
	cp	6
	jp	c,gnhletpressed
	jp	getnumhloop
gnhnumpressed:
	ld	(hl),a
	inc hl
	add a,48
	call IPutC
	djnz getnumhloop
	jp	gnhdone
gnhletpressed:
	add a,10
	ld	(hl),a
	inc hl
	add a,55
   call IPutC
	djnz getnumhloop
gnhdone:
	dec hl
	ld	b,(hl)
	dec hl
	ld	a,(hl)
	rlca
	rlca
	rlca
	rlca
	or	b
   res curAble,(iy+curFlags)
	ret

DispHexHL:
   push af
	push bc
	push de
	push hl
	push ix
   ld a,h
   call DispHexA
   ld a,l
   call DispHexA
	pop ix
	pop hl
	pop de
	pop bc
   pop af
   ret

DispHexA:
	push ix
	push af
   push hl
   push bc
   push af
   rrca
   rrca
   rrca
   rrca
   call dispha
   pop af
   call dispha
   pop bc
   pop hl
	pop af
	pop ix
   ret
dispha:
   and 15
   cp 10
   jp nc,dhlet
   add a,48
   jp dispdh
dhlet:
   add a,55
dispdh:
   call IPutC
   ret

;DialogBox
; Input
;  (H,L) = (y,x) upper left
;  (D,E) = (y,x) lower right
;H and l must be >= 1
;D must be <= 62
;E must be <= 93
;Text inside the box must be displayed manually
DialogBox:
	push hl
	push de
	dec h
	dec l
	inc d 
	inc d
	inc e
	inc e
	B_CALL EraseRectBorder
	pop de
	pop hl
	push hl
	push de
	B_CALL DrawRectBorderClear	
	pop de
	pop hl
	push hl
	push de
	inc d
	inc e
	B_CALL DrawRectBorder
	pop de
	pop hl
	ld	a,h
	xor 63 ;Adjust for funny IPoint coordinates
	ld	h,a 
	ld	a,d
	xor 63
	ld	b,l
	ld	c,h
	ld	d,0
	B_CALL IPoint ;(b,c) = (x,y xor 63) - upper left
	ld	b,e
	B_CALL IPoint
	inc b
	B_CALL IPoint
	dec c
	B_CALL IPoint
	ld	c,a
	dec c
	B_CALL IPoint
	ld	b,l
	B_CALL IPoint
	inc b
	B_CALL IPoint
	dec b
	inc c
	B_CALL IPoint
	ret

VStrLen:
	ld b,0
VStrLen_Loop:
	ld a,(hl)
	or a
	ret z
	push hl
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	B_CALL SFont_Len
	ld a,b
	pop bc
	pop hl
	inc hl
	add a,b
	ld b,a
	jr VStrLen_Loop

fastCopy:
	di
	ld hl,plotsscreen
	ld b,64
	ld a,07h
	out (10h),a
	ld a,80h-1
layerloop1:
	push bc
	ld b,0Ch
	inc a
	ld (OP1),a
	call lcddelay
	out (10h),a
	call lcddelay
	ld a,20h
	out (10h),a
layerloop2:
	ld a,(hl)
	call lcddelay
	out (11h),a
	inc hl
	djnz layerloop2
	pop bc
	ld a,(OP1)
	djnz layerloop1
	ld a,5
	call lcddelay
	out (10h),a
	ei
	ret
lcddelay:
	push af
lcddelayloop:
	in a,(2)
	and 2
	jr z,lcddelayloop
	pop af
	ret

fixVarNames:
;Converts TI-OS style variable name in OP1 to ASCIIZ
	ld a,(OP1)
	cp 01h ;list
	jr z,fixList
	cp 0Dh
	jr z,fixList
	cp 02h ;matrix
	jr z,fixMatrix
	cp 03h ;equation
	jr z,fixEquation
	cp 04h
	jr z,fixString
	cp 07h
	jr z,fixPicture
	cp 08h
	jr z,fixGDB
	ret
fixList:
	ld a,(OP1+2)
	cp 10
	jp p,fixNamedList
	add a,31h
	ld (OP1+2),a
	ld a,'L'
	ld (OP1+1),a
	ret
fixNamedList:
	ld a,LlistL
	ld (OP1+1),a
	ret
fixMatrix:
	ld a,(OP1+2)
	inc a
	ld hl,sMatrixTable-4
	ld de,4
	ld b,a
f_m_1:
	add hl,de
	djnz f_m_1
	ld de,OP1+1
	ld bc,4
	ldir
	ret
sMatrixTable:
	DB 0C1h,"A",5Dh,0
	DB 0C1h,"B",5Dh,0
	DB 0C1h,"C",5Dh,0
	DB 0C1h,"D",5Dh,0
	DB 0C1h,"E",5Dh,0
	DB 0C1h,"F",5Dh,0
	DB 0C1h,"G",5Dh,0
	DB 0C1h,"H",5Dh,0
	DB 0C1h,"I",5Dh,0
	DB 0C1h,"J",5Dh,0
fixPicture:
	ld a,(OP1+2)
	inc a
	ld hl,sPictureTable-5
	ld de,5
	ld b,a
f_p_1:
	add hl,de
	djnz f_p_1
	ld de,OP1+1
	ld bc,5
	ldir
	ret
sPictureTable:
	DB "Pic1",0
	DB "Pic2",0
	DB "Pic3",0
	DB "Pic4",0
	DB "Pic5",0
	DB "Pic6",0
	DB "Pic7",0
	DB "Pic8",0
	DB "Pic9",0
	DB "Pic0",0
fixGDB:
	ld a,(OP1+2)
	inc a
	ld hl,sGDBTable-5
	ld de,5
	ld b,a
f_gdb_1:
	add hl,de
	djnz f_gdb_1
	ld de,OP1+1
	ld bc,5
	ldir
	ret
sGDBTable:
	DB "GDB1",0
	DB "GDB2",0
	DB "GDB3",0
	DB "GDB4",0
	DB "GDB5",0
	DB "GDB6",0
	DB "GDB7",0
	DB "GDB8",0
	DB "GDB9",0
	DB "GDB0",0
fixEquation:
	ld a,(OP1+2)
	cp 7Fh
	jp p,fixEquation_s
	cp 3Fh
	jp p,fixEquation_r
	cp 1Fh
	jp p,fixEquation_l
	sub 10h
	ld hl,sEquTableY-3
	inc a
	ld b,a
	ld de,3
fe_y_1:
	add hl,de
	djnz fe_y_1
	ld de,OP1+1
	ld bc,3
	ldir
	ret
sEquTableY:
	DB "Y",81h,0
	DB "Y",82h,0
	DB "Y",83h,0
	DB "Y",84h,0
	DB "Y",85h,0
	DB "Y",86h,0
	DB "Y",87h,0
	DB "Y",88h,0
	DB "Y",89h,0
	DB "Y",80h,0
fixEquation_l:
	ld hl,sEquTableL-4
	sub 20h
	inc a
	ld b,a
	ld de,4
fe_l_1:
	add hl,de
	djnz fe_l_1
	ld de,OP1+1
	ld bc,4
	ldir
	ret
sEquTableL:
	DB "X",81h,0Dh,0
	DB "Y",81h,0Dh,0
	DB "X",82h,0Dh,0
	DB "Y",82h,0Dh,0
	DB "X",83h,0Dh,0
	DB "Y",83h,0Dh,0
	DB "X",84h,0Dh,0
	DB "Y",84h,0Dh,0
	DB "X",85h,0Dh,0
	DB "Y",85h,0Dh,0
	DB "X",86h,0Dh,0
	DB "Y",86h,0Dh,0
fixEquation_s:
	sub 80h
	add a,75h
	ld (OP1+1),a
	xor a
	ld (OP1+2),a
	ret
fixEquation_r:
	ld hl,sEquTable-3
	ld a,(OP1+2)
	sub 40h
	inc a
	ld b,a
	ld de,3
fe_r_1:
	add hl,de
	djnz fe_r_1
	ld de,OP1+1
	ld bc,3
	ldir
	ret
sEquTable:
	DB "r1",0
	DB "r2",0
	DB "r3",0
	DB "r4",0
	DB "r5",0
	DB "r6",0
fixString:
	ld hl,sStrTable-5
	ld a,(OP1+2)
	inc a
	ld b,a
	ld de,5
fs_1:
	add hl,de
	djnz fs_1
	ld de,OP1+1
	ld bc,5
	ldir
	ret
sStrTable:
	DB "Str1",0
	DB "Str2",0
	DB "Str3",0
	DB "Str4",0
	DB "Str5",0
	DB "Str6",0
	DB "Str7",0
	DB "Str8",0
	DB "Str9",0
	DB "Str0",0

VEraseEOL:
	ld a,' '
	B_CALL VPutMap
	ld a,(pencol)
	cp c
	jp m,VEraseEOL
	ret

Traverse_symTable:
	ld hl,symTable
	inc a
	ld c,a
tstBegin:
	push bc
	push hl
	ld bc,(pTemp)
	or a
	sbc hl,bc
	pop hl
	pop bc
	ret c
	jr nz,$F
	scf
	ret
$$:ld a,(hl)
	and 1Fh
	ld b,a
	ld de,6
	sbc hl,de
	ld e,3
	cp AppVarObj
	jr z,tstMove1
	cp ProgObj
	jr z,tstMove1
	cp ProtProgObj
	jr z,tstMove1
	cp TempProgObj
	jr z,tstMove1
	cp 17h
	jr z,tstMove1
	dec hl
	ld a,(hl)
	inc hl
	cp tVarLst
	jr nz,tstMove2
tstMove1:
	ld e,(hl)
	dec hl
tstMove2:
	ld a,b
	ld b,e
	ld de,OP1
	ld (de),a
	inc de
tstCopy:
	ld a,(hl)
	ld (de),a
	inc de
	dec hl
	djnz tstCopy
	xor a
	ld (de),a
	ld a,(OP1)
	cp 17h
	jr z,$F
	cp ProgObj
	jr z,$F
	cp ProtProgObj
	jr z,$F
	cp AppVarObj
	jr z,$F
	or a
	jr z,tstReal
	jr tstContinue
tstReal:
	ld a,(OP1+1)
	cp 5Ch
	jp p,tstBegin
	jr tstContinue
$$:ld a,(OP1+1)
	cp 30h
	jp m,tstBegin
tstContinue:
	ld a,(OP1)
	push hl
	call filterTypes
	pop hl
	jr c,tstBegin
	dec c
	jr nz,tstBegin
	ld hl,OP1
	ld de,OP2
	ld bc,11
	ldir
	ret
filterTypes:
	ld a,(OP1)
	ld b,a
	ld hl,bTypeTable
filterTypesLoop:
	ld a,(hl)
	cp b
	ret z
	cp 0FFh
	jr z,$F
	inc hl
	jr filterTypesLoop
$$:scf
	ret
bTypeTable:
	DB 0,1,2,3,4,5,6,7,8,0Ch,0Dh,15h,0FFh

cmpstr:
       ld a,(de)
       cp (hl)
       ret nz
       or a
       ret z
       inc de
       inc hl
       jr cmpstr

cmpstrb:
       ld a,(de)
       cp (hl)
       ret nz
       inc de
       inc hl
       djnz cmpstrb
       xor a
       ret

putsb:
       push bc
       push hl
$$:    ld a,(hl)
       B_CALL PutC
       inc hl
       djnz $B
       pop hl
       pop bc
       ret
